diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/msdu-aggregator.cc ns-3.36/src/wifi/model/msdu-aggregator.cc
--- ns-3.35/src/wifi/model/msdu-aggregator.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/msdu-aggregator.cc	2022-04-30 18:23:58.210735000 -0700
@@ -25,7 +25,7 @@
 #include "qos-txop.h"
 #include "wifi-remote-station-manager.h"
 #include "ns3/ht-capabilities.h"
-#include "regular-wifi-mac.h"
+#include "wifi-mac.h"
 #include "wifi-mac-queue.h"
 #include "wifi-mac-trailer.h"
 #include "ns3/ht-frame-exchange-manager.h"
@@ -66,7 +66,7 @@
 }
 
 void
-MsduAggregator::SetWifiMac (const Ptr<RegularWifiMac> mac)
+MsduAggregator::SetWifiMac (const Ptr<WifiMac> mac)
 {
   NS_LOG_FUNCTION (this << mac);
   m_mac = mac;
@@ -84,13 +84,11 @@
 
 Ptr<WifiMacQueueItem>
 MsduAggregator::GetNextAmsdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
-                              Time availableTime, WifiMacQueueItem::ConstIterator& queueIt) const
+                              Time availableTime) const
 {
   NS_LOG_FUNCTION (this << *peekedItem << &txParams << availableTime);
 
   Ptr<WifiMacQueue> queue = m_mac->GetTxopQueue (peekedItem->GetQueueAc ());
-  auto it = peekedItem->GetQueueIterator ();
-  NS_ASSERT ((*it)->GetPacket () == peekedItem->GetPacket ());
 
   uint8_t tid = peekedItem->GetHeader ().GetQosTid ();
   Mac48Address recipient = peekedItem->GetHeader ().GetAddr1 ();
@@ -119,27 +117,23 @@
       return nullptr;
     }
 
-  Ptr<WifiMacQueueItem> amsdu = *it;  // amsdu points to the peeked MPDU, but it's non-const
+  Ptr<WifiMacQueueItem> amsdu = peekedItem->GetItem ();  // amsdu points to the peeked MPDU, but it's non-const
   uint8_t nMsdu = 1;
+  peekedItem = queue->PeekByTidAndAddress (tid, recipient, peekedItem);
 
-  it++;
-
-  while ((it = queue->PeekByTidAndAddress (tid, recipient, it)) != queue->end ()
-         && m_htFem->TryAggregateMsdu (*it, txParams, availableTime))
+  while (peekedItem != nullptr
+         && m_htFem->TryAggregateMsdu (peekedItem, txParams, availableTime))
     {
-      // dequeue the MSDU being aggregated and advance the current iterator
-      // before it is invalidated
-      Ptr<WifiMacQueueItem> msdu = *it++;
+      // find the next MPDU before dequeuing the current one
+      Ptr<const WifiMacQueueItem> msdu = peekedItem;
+      peekedItem = queue->PeekByTidAndAddress (tid, recipient, peekedItem);
       queue->DequeueIfQueued (msdu);
 
-      auto pos = std::next (amsdu->GetQueueIterator ());
-      queue->DequeueIfQueued (amsdu);
-
-      amsdu->Aggregate (msdu);
-      bool ret = queue->Insert (pos, amsdu);
-      // The size of a WifiMacQueue is measured as number of packets. We dequeued
-      // two packets, so there is certainly room for inserting one packet
-      NS_ABORT_IF (!ret);
+      // perform A-MSDU aggregation
+      queue->Transform (amsdu, [&msdu](Ptr<WifiMacQueueItem> amsdu)
+                               {
+                                 amsdu->Aggregate (msdu);
+                               });
 
       nMsdu++;
     }
@@ -151,8 +145,6 @@
     }
 
   // Aggregation succeeded
-  queueIt = it;
-
   return amsdu;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/msdu-aggregator.h ns-3.36/src/wifi/model/msdu-aggregator.h
--- ns-3.35/src/wifi/model/msdu-aggregator.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/msdu-aggregator.h	2022-04-30 18:23:58.210735000 -0700
@@ -33,7 +33,7 @@
 class Packet;
 class QosTxop;
 class WifiTxVector;
-class RegularWifiMac;
+class WifiMac;
 class HtFrameExchangeManager;
 class WifiTxParameters;
 
@@ -96,13 +96,10 @@
    * \param peekedItem the MSDU which we attempt to aggregate other MSDUs to
    * \param txParams the TX parameters for the current frame
    * \param availableTime the time available for the frame exchange
-   * \param[out] queueIt a queue iterator pointing to the queue item following the
-   *                     last item used to prepare the returned A-MSDU, if any; otherwise,
-   *                     its value is unchanged
    * \return the resulting A-MSDU, if aggregation is possible, a null pointer otherwise.
    */
   Ptr<WifiMacQueueItem> GetNextAmsdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
-                                      Time availableTime, WifiMacQueueItem::ConstIterator& queueIt) const;
+                                      Time availableTime) const;
 
   /**
    * Determine the maximum size for an A-MSDU of the given TID that can be sent
@@ -128,7 +125,7 @@
    *
    * \param mac the MAC layer to use
    */
-  void SetWifiMac (const Ptr<RegularWifiMac> mac);
+  void SetWifiMac (const Ptr<WifiMac> mac);
 
   /**
    * Calculate how much padding must be added to the end of an A-MSDU of the
@@ -145,7 +142,7 @@
   void DoDispose () override;
 
 private:
-  Ptr<RegularWifiMac> m_mac;            //!< the MAC of this station
+  Ptr<WifiMac> m_mac;                   //!< the MAC of this station
   Ptr<HtFrameExchangeManager> m_htFem;  //!< the HT Frame Exchange Manager of this station
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/non-ht/dsss-phy.cc ns-3.36/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.35/src/wifi/model/non-ht/dsss-phy.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/non-ht/dsss-phy.cc	2022-04-30 18:23:58.210735000 -0700
@@ -306,11 +306,9 @@
                                           true,
                                           MakeBoundCallback (&GetCodeRate, uniqueName),
                                           MakeBoundCallback (&GetConstellationSize, uniqueName),
-                                          MakeBoundCallback (&GetDataRate, uniqueName, modClass), //PhyRate is equivalent to DataRate
                                           MakeCallback (&GetDataRateFromTxVector), //PhyRate is equivalent to DataRate
-                                          MakeBoundCallback (&GetDataRate, uniqueName, modClass),
                                           MakeCallback (&GetDataRateFromTxVector),
-                                          MakeCallback (&IsModeAllowed));
+                                          MakeCallback (&IsAllowed));
 }
 
 WifiCodeRate
@@ -330,12 +328,11 @@
 {
   WifiMode mode = txVector.GetMode ();
   return DsssPhy::GetDataRate (mode.GetUniqueName (),
-                               mode.GetModulationClass (),
-                               22, 0, 1); //dummy values since unused
+                               mode.GetModulationClass ());
 }
 
 uint64_t
-DsssPhy::GetDataRate (const std::string& name, WifiModulationClass modClass, uint16_t /* channelWidth */, uint16_t /* guardInterval */, uint8_t /* nss */)
+DsssPhy::GetDataRate (const std::string& name, WifiModulationClass modClass)
 {
   uint16_t constellationSize = GetConstellationSize (name);
   uint16_t divisor = 0;
@@ -357,7 +354,7 @@
 }
 
 bool
-DsssPhy::IsModeAllowed (uint16_t /* channelWidth */, uint8_t /* nss */)
+DsssPhy::IsAllowed (const WifiTxVector& /*txVector*/)
 {
   return true;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/non-ht/dsss-phy.h ns-3.36/src/wifi/model/non-ht/dsss-phy.h
--- ns-3.35/src/wifi/model/non-ht/dsss-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/non-ht/dsss-phy.h	2022-04-30 18:23:58.210735000 -0700
@@ -136,23 +136,18 @@
    *
    * \param name the unique name of the DSSS or HR/DSSS mode
    * \param modClass the modulation class, must be either WIFI_MOD_CLASS_DSSS or WIFI_MOD_CLASS_HR_DSSS
-   * \param channelWidth the considered channel width in MHz
-   * \param guardInterval the considered guard interval duration in nanoseconds
-   * \param nss the considered number of streams
    *
    * \return the data bit rate of this signal in bps.
    */
-  static uint64_t GetDataRate (const std::string& name, WifiModulationClass modClass, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  static uint64_t GetDataRate (const std::string& name, WifiModulationClass modClass);
   /**
-   * Check whether the combination of <WifiMode, channel width, NSS> is allowed.
-   * This function is used as a callback for WifiMode operation, and always
-   * returns true since there is no limitation for any mode in DsssPhy.
+   * Check whether the combination in TXVECTOR is allowed.
+   * This function is used as a callback for WifiMode operation.
    *
-   * \param channelWidth the considered channel width in MHz
-   * \param nss the considered number of streams
-   * \returns true.
+   * \param txVector the TXVECTOR
+   * \returns true if this combination is allowed, false otherwise.
    */
-  static bool IsModeAllowed (uint16_t channelWidth, uint8_t nss);
+  static bool IsAllowed (const WifiTxVector& txVector);
 
 private:
   PhyFieldRxStatus DoEndReceiveField (WifiPpduField field, Ptr<Event> event) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.36/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.35/src/wifi/model/non-ht/erp-ofdm-phy.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/non-ht/erp-ofdm-phy.cc	2022-04-30 18:23:58.210735000 -0700
@@ -176,11 +176,9 @@
                                           isMandatory,
                                           MakeBoundCallback (&GetCodeRate, uniqueName),
                                           MakeBoundCallback (&GetConstellationSize, uniqueName),
-                                          MakeBoundCallback (&GetPhyRate, uniqueName),
                                           MakeCallback (&GetPhyRateFromTxVector),
-                                          MakeBoundCallback (&GetDataRate, uniqueName),
                                           MakeCallback (&GetDataRateFromTxVector),
-                                          MakeCallback (&IsModeAllowed));
+                                          MakeCallback (&IsAllowed));
 }
 
 WifiCodeRate
@@ -196,11 +194,11 @@
 }
 
 uint64_t
-ErpOfdmPhy::GetPhyRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+ErpOfdmPhy::GetPhyRate (const std::string& name, uint16_t channelWidth)
 {
   WifiCodeRate codeRate = GetCodeRate (name);
   uint16_t constellationSize = GetConstellationSize (name);
-  uint64_t dataRate = OfdmPhy::CalculateDataRate (codeRate, constellationSize, channelWidth, guardInterval, nss);
+  uint64_t dataRate = OfdmPhy::CalculateDataRate (codeRate, constellationSize, channelWidth);
   return OfdmPhy::CalculatePhyRate (codeRate, dataRate);
 }
 
@@ -208,30 +206,26 @@
 ErpOfdmPhy::GetPhyRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
 {
   return GetPhyRate (txVector.GetMode ().GetUniqueName (),
-                     txVector.GetChannelWidth (),
-                     txVector.GetGuardInterval (),
-                     txVector.GetNss ());
+                     txVector.GetChannelWidth ());
 }
 
 uint64_t
 ErpOfdmPhy::GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
 {
   return GetDataRate (txVector.GetMode ().GetUniqueName (),
-                      txVector.GetChannelWidth (),
-                      txVector.GetGuardInterval (),
-                      txVector.GetNss ());
+                      txVector.GetChannelWidth ());
 }
 
 uint64_t
-ErpOfdmPhy::GetDataRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+ErpOfdmPhy::GetDataRate (const std::string& name, uint16_t channelWidth)
 {
   WifiCodeRate codeRate = GetCodeRate (name);
   uint16_t constellationSize = GetConstellationSize (name);
-  return OfdmPhy::CalculateDataRate (codeRate, constellationSize, channelWidth, guardInterval, nss);
+  return OfdmPhy::CalculateDataRate (codeRate, constellationSize, channelWidth);
 }
 
 bool
-ErpOfdmPhy::IsModeAllowed (uint16_t /* channelWidth */, uint8_t /* nss */)
+ErpOfdmPhy::IsAllowed (const WifiTxVector& /*txVector*/)
 {
   return true;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/non-ht/erp-ofdm-phy.h ns-3.36/src/wifi/model/non-ht/erp-ofdm-phy.h
--- ns-3.35/src/wifi/model/non-ht/erp-ofdm-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/non-ht/erp-ofdm-phy.h	2022-04-30 18:23:58.210735000 -0700
@@ -144,12 +144,10 @@
    *
    * \param name the unique name of the ERP-OFDM mode
    * \param channelWidth the considered channel width in MHz
-   * \param guardInterval the considered guard interval duration in nanoseconds
-   * \param nss the considered number of streams
    *
    * \return the physical bit rate of this signal in bps.
    */
-  static uint64_t GetPhyRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  static uint64_t GetPhyRate (const std::string& name, uint16_t channelWidth);
   /**
    * Return the PHY rate corresponding to
    * the supplied TXVECTOR.
@@ -179,22 +177,18 @@
    *
    * \param name the unique name of the ERP-OFDM mode
    * \param channelWidth the considered channel width in MHz
-   * \param guardInterval the considered guard interval duration in nanoseconds
-   * \param nss the considered number of streams
    *
    * \return the data bit rate of this signal in bps.
    */
-  static uint64_t GetDataRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  static uint64_t GetDataRate (const std::string& name, uint16_t channelWidth);
   /**
-   * Check whether the combination of <WifiMode, channel width, NSS> is allowed.
-   * This function is used as a callback for WifiMode operation, and always
-   * returns true since there is no limitation for any mode in ErpOfdmPhy.
+   * Check whether the combination in TXVECTOR is allowed.
+   * This function is used as a callback for WifiMode operation.
    *
-   * \param channelWidth the considered channel width in MHz
-   * \param nss the considered number of streams
-   * \returns true.
+   * \param txVector the TXVECTOR
+   * \returns true if this combination is allowed, false otherwise.
    */
-  static bool IsModeAllowed (uint16_t channelWidth, uint8_t nss);
+  static bool IsAllowed (const WifiTxVector& txVector);
 
 private:
   WifiMode GetHeaderMode (const WifiTxVector& txVector) const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/non-ht/ofdm-phy.cc ns-3.36/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.35/src/wifi/model/non-ht/ofdm-phy.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/non-ht/ofdm-phy.cc	2022-04-30 18:23:58.210735000 -0700
@@ -492,11 +492,9 @@
                                           isMandatory,
                                           MakeBoundCallback (&GetCodeRate, uniqueName),
                                           MakeBoundCallback (&GetConstellationSize, uniqueName),
-                                          MakeBoundCallback (&GetPhyRate, uniqueName),
                                           MakeCallback (&GetPhyRateFromTxVector),
-                                          MakeBoundCallback (&GetDataRate, uniqueName),
                                           MakeCallback (&GetDataRateFromTxVector),
-                                          MakeCallback (&IsModeAllowed));
+                                          MakeCallback (&IsAllowed));
 }
 
 WifiCodeRate
@@ -512,10 +510,10 @@
 }
 
 uint64_t
-OfdmPhy::GetPhyRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+OfdmPhy::GetPhyRate (const std::string& name, uint16_t channelWidth)
 {
   WifiCodeRate codeRate = GetCodeRate (name);
-  uint64_t dataRate = GetDataRate (name, channelWidth, guardInterval, nss);
+  uint64_t dataRate = GetDataRate (name, channelWidth);
   return CalculatePhyRate (codeRate, dataRate);
 }
 
@@ -529,9 +527,7 @@
 OfdmPhy::GetPhyRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
 {
   return GetPhyRate (txVector.GetMode ().GetUniqueName (),
-                     txVector.GetChannelWidth (),
-                     txVector.GetGuardInterval (),
-                     txVector.GetNss ());
+                     txVector.GetChannelWidth ());
 }
 
 double
@@ -556,21 +552,19 @@
 OfdmPhy::GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t /* staId */)
 {
   return GetDataRate (txVector.GetMode ().GetUniqueName (),
-                      txVector.GetChannelWidth (),
-                      txVector.GetGuardInterval (),
-                      txVector.GetNss ());
+                      txVector.GetChannelWidth ());
 }
 
 uint64_t
-OfdmPhy::GetDataRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+OfdmPhy::GetDataRate (const std::string& name, uint16_t channelWidth)
 {
   WifiCodeRate codeRate = GetCodeRate (name);
   uint16_t constellationSize = GetConstellationSize (name);
-  return CalculateDataRate (codeRate, constellationSize, channelWidth, guardInterval, nss);
+  return CalculateDataRate (codeRate, constellationSize, channelWidth);
 }
 
 uint64_t
-OfdmPhy::CalculateDataRate (WifiCodeRate codeRate, uint16_t constellationSize, uint16_t channelWidth, uint16_t /* guardInterval */, uint8_t /* nss */)
+OfdmPhy::CalculateDataRate (WifiCodeRate codeRate, uint16_t constellationSize, uint16_t channelWidth)
 {
   double symbolDuration = 3.2; //in us
   uint16_t guardInterval = 800; //in ns
@@ -599,7 +593,7 @@
 }
 
 bool
-OfdmPhy::IsModeAllowed (uint16_t /* channelWidth */, uint8_t /* nss */)
+OfdmPhy::IsAllowed (const WifiTxVector& /*txVector*/)
 {
   return true;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/non-ht/ofdm-phy.h ns-3.36/src/wifi/model/non-ht/ofdm-phy.h
--- ns-3.35/src/wifi/model/non-ht/ofdm-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/non-ht/ofdm-phy.h	2022-04-30 18:23:58.210735000 -0700
@@ -265,12 +265,10 @@
    *
    * \param name the unique name of the OFDM mode
    * \param channelWidth the considered channel width in MHz
-   * \param guardInterval the considered guard interval duration in nanoseconds
-   * \param nss the considered number of streams
    *
    * \return the physical bit rate of this signal in bps.
    */
-  static uint64_t GetPhyRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  static uint64_t GetPhyRate (const std::string& name, uint16_t channelWidth);
 
   /**
    * Return the PHY rate corresponding to
@@ -301,22 +299,18 @@
    *
    * \param name the unique name of the OFDM mode
    * \param channelWidth the considered channel width in MHz
-   * \param guardInterval the considered guard interval duration in nanoseconds
-   * \param nss the considered number of streams
    *
    * \return the data bit rate of this signal in bps.
    */
-  static uint64_t GetDataRate (const std::string& name, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  static uint64_t GetDataRate (const std::string& name, uint16_t channelWidth);
   /**
-   * Check whether the combination of <WifiMode, channel width, NSS> is allowed.
-   * This function is used as a callback for WifiMode operation, and always
-   * returns true since there is no limitation for any mode in OfdmPhy.
+   * Check whether the combination in TXVECTOR is allowed.
+   * This function is used as a callback for WifiMode operation.
    *
-   * \param channelWidth the considered channel width in MHz
-   * \param nss the considered number of streams
-   * \returns true.
+   * \param txVector the TXVECTOR
+   * \returns true if this combination is allowed, false otherwise.
    */
-  static bool IsModeAllowed (uint16_t channelWidth, uint8_t nss);
+  static bool IsAllowed (const WifiTxVector& txVector);
 
 protected:
   PhyFieldRxStatus DoEndReceiveField (WifiPpduField field, Ptr<Event> event) override;
@@ -399,13 +393,10 @@
    * \param codeRate the code rate of the mode
    * \param constellationSize the size of modulation constellation
    * \param channelWidth the considered channel width in MHz
-   * \param guardInterval the considered guard interval duration in nanoseconds
-   * \param nss the considered number of streams
    *
    * \return the data bit rate of this signal in bps.
    */
-  static uint64_t CalculateDataRate (WifiCodeRate codeRate, uint16_t constellationSize, uint16_t channelWidth,
-                                     uint16_t guardInterval, uint8_t nss);
+  static uint64_t CalculateDataRate (WifiCodeRate codeRate, uint16_t constellationSize, uint16_t channelWidth);
   /**
    * Calculates data rate from the supplied parameters.
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/originator-block-ack-agreement.cc ns-3.36/src/wifi/model/originator-block-ack-agreement.cc
--- ns-3.35/src/wifi/model/originator-block-ack-agreement.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/originator-block-ack-agreement.cc	2022-04-30 18:23:58.210735000 -0700
@@ -47,31 +47,31 @@
 bool
 OriginatorBlockAckAgreement::IsPending (void) const
 {
-  return (m_state == PENDING) ? true : false;
+  return m_state == PENDING;
 }
 
 bool
 OriginatorBlockAckAgreement::IsEstablished (void) const
 {
-  return (m_state == ESTABLISHED) ? true : false;
+  return m_state == ESTABLISHED;
 }
 
 bool
 OriginatorBlockAckAgreement::IsRejected (void) const
 {
-  return (m_state == REJECTED) ? true : false;
+  return m_state == REJECTED;
 }
 
 bool
 OriginatorBlockAckAgreement::IsNoReply (void) const
 {
-  return (m_state == NO_REPLY) ? true : false;
+  return m_state == NO_REPLY;
 }
 
 bool
 OriginatorBlockAckAgreement::IsReset (void) const
 {
-  return (m_state == RESET) ? true : false;
+  return m_state == RESET;
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/phy-entity.cc ns-3.36/src/wifi/model/phy-entity.cc
--- ns-3.35/src/wifi/model/phy-entity.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/phy-entity.cc	2022-04-30 18:23:58.210735000 -0700
@@ -385,6 +385,7 @@
         {
           m_wifiPhy->SwitchMaybeToCcaBusy (m_wifiPhy->GetMeasurementChannelWidth (nullptr));
         }
+      DropPreambleEvent (ppdu, WifiPhyRxfailureReason::POWERED_OFF, endRx, m_wifiPhy->GetMeasurementChannelWidth (ppdu));
       return;
     }
 
@@ -395,6 +396,7 @@
         {
           m_wifiPhy->SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (ppdu));
         }
+      DropPreambleEvent (ppdu, WifiPhyRxfailureReason::TRUNCATED_TX, endRx, m_wifiPhy->GetMeasurementChannelWidth (ppdu));
       return;
     }
 
@@ -921,6 +923,11 @@
       endRxPayloadEvent.Cancel ();
     }
   m_endRxPayloadEvents.clear ();
+  for (auto & endMpduEvent : m_endOfMpduEvents)
+    {
+      endMpduEvent.Cancel ();
+    }
+  m_endOfMpduEvents.clear ();
 }
 
 bool
@@ -1031,6 +1038,12 @@
 }
 
 void
+PhyEntity::NotifyPayloadBegin (const WifiTxVector& txVector, const Time& payloadDuration)
+{
+  m_wifiPhy->m_phyRxPayloadBeginTrace (txVector, payloadDuration);
+}
+
+void
 PhyEntity::StartTx (Ptr<WifiPpdu> ppdu)
 {
   NS_LOG_FUNCTION (this << ppdu);
@@ -1048,6 +1061,7 @@
   txParams->duration = txDuration;
   txParams->psd = txPowerSpectrum;
   txParams->ppdu = ppdu;
+  txParams->txCenterFreq = GetCenterFrequencyForChannelWidth (ppdu->GetTxVector ());
   NS_LOG_DEBUG ("Starting " << type << " with power " << WToDbm (txPowerWatts) << " dBm on channel " << +m_wifiPhy->GetChannelNumber () << " for " << txParams->duration.As (Time::MS));
   NS_LOG_DEBUG ("Starting " << type << " with integrated spectrum power " << WToDbm (Integral (*txPowerSpectrum)) << " dBm; spectrum model Uid: " << txPowerSpectrum->GetSpectrumModel ()->GetUid ());
   auto spectrumWifiPhy = DynamicCast<SpectrumWifiPhy> (m_wifiPhy);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/phy-entity.h ns-3.36/src/wifi/model/phy-entity.h
--- ns-3.35/src/wifi/model/phy-entity.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/phy-entity.h	2022-04-30 18:23:58.210735000 -0700
@@ -763,6 +763,14 @@
   uint16_t GetCenterFrequencyForChannelWidth (const WifiTxVector& txVector) const;
 
   /**
+   * Fire the trace indicating that the PHY is starting to receive the payload of a PPDU.
+   *
+   * \param txVector the TXVECTOR used to transmit the PPDU
+   * \param payloadDuration the TX duration of the PPDU payload
+   */
+  void NotifyPayloadBegin (const WifiTxVector& txVector, const Time& payloadDuration);
+
+  /**
    * \param currentChannelWidth channel width of the current transmission (MHz)
    * \return the width of the guard band (MHz)
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/qos-frame-exchange-manager.cc ns-3.36/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.35/src/wifi/model/qos-frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/qos-frame-exchange-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -277,8 +277,7 @@
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (mpdu->GetHeader ());
 
-  WifiMacQueueItem::ConstIterator queueIt;
-  Ptr<WifiMacQueueItem> item = edca->GetNextMpdu (mpdu, txParams, availableTime, initialFrame, queueIt);
+  Ptr<WifiMacQueueItem> item = edca->GetNextMpdu (mpdu, txParams, availableTime, initialFrame);
 
   if (item == nullptr)
     {
@@ -456,13 +455,15 @@
       return FrameExchangeManager::GetFrameDurationId (header, size, txParams, fragmentedPacket);
     }
 
+  NS_ASSERT (txParams.m_acknowledgment && txParams.m_acknowledgment->acknowledgmentTime != Time::Min ());
+
   // under multiple protection settings, if the TXOP limit is not null, Duration/ID
   // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
   // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
   // of 802.11-2016)
   return std::max (m_edca->GetRemainingTxop ()
                    - m_phy->CalculateTxDuration (size, txParams.m_txVector, m_phy->GetPhyBand ()),
-                   Seconds (0));
+                   txParams.m_acknowledgment->acknowledgmentTime);
 }
 
 Time
